import{S as ls,i as ps,s as ds,e as a,k as p,w as y,t as o,M as cs,c as s,d as t,m as d,a as i,x as w,h as r,b as c,G as e,g as b,y as I,q as P,o as k,B as D,v as fs,L as ya}from"../../../../chunks/vendor-hf-doc-builder.js";import{D as O}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as wa}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as rs}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as xa}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function ms(U){let m,$,h,f,v;return f=new wa({props:{code:`import PIL
import requests
import torch
from io import BytesIO

from diffusers import StableDiffusionInpaintPipeline


def download_image(url):
    response = requests.get(url)
    return PIL.Image.open(BytesIO(response.content)).convert("RGB")


img_url = "https://raw.githubusercontent.com/CompVis/latent-diffusion/main/data/inpainting_examples/overture-creations-5sI6fQgYIuo.png"
mask_url = "https://raw.githubusercontent.com/CompVis/latent-diffusion/main/data/inpainting_examples/overture-creations-5sI6fQgYIuo_mask.png"

init_image = download_image(img_url).resize((512, 512))
mask_image = download_image(mask_url).resize((512, 512))

pipe = StableDiffusionInpaintPipeline.from_pretrained(
    "runwayml/stable-diffusion-inpainting", torch_dtype=torch.float16
)
pipe = pipe.to("cuda")

prompt = "Face of a yellow cat, high resolution, sitting on a park bench"
image = pipe(prompt=prompt, image=init_image, mask_image=mask_image).images[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> PIL
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionInpaintPipeline


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">download_image</span>(<span class="hljs-params">url</span>):
<span class="hljs-meta">... </span>    response = requests.get(url)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> PIL.Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)


<span class="hljs-meta">&gt;&gt;&gt; </span>img_url = <span class="hljs-string">&quot;https://raw.githubusercontent.com/CompVis/latent-diffusion/main/data/inpainting_examples/overture-creations-5sI6fQgYIuo.png&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_url = <span class="hljs-string">&quot;https://raw.githubusercontent.com/CompVis/latent-diffusion/main/data/inpainting_examples/overture-creations-5sI6fQgYIuo_mask.png&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>init_image = download_image(img_url).resize((<span class="hljs-number">512</span>, <span class="hljs-number">512</span>))
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_image = download_image(mask_url).resize((<span class="hljs-number">512</span>, <span class="hljs-number">512</span>))

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionInpaintPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;runwayml/stable-diffusion-inpainting&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;Face of a yellow cat, high resolution, sitting on a park bench&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(prompt=prompt, image=init_image, mask_image=mask_image).images[<span class="hljs-number">0</span>]`}}),{c(){m=a("p"),$=o("Examples:"),h=p(),y(f.$$.fragment)},l(l){m=s(l,"P",{});var _=i(m);$=r(_,"Examples:"),_.forEach(t),h=d(l),w(f.$$.fragment,l)},m(l,_){b(l,m,_),e(m,$),b(l,h,_),I(f,l,_),v=!0},p:ya,i(l){v||(P(f.$$.fragment,l),v=!0)},o(l){k(f.$$.fragment,l),v=!1},d(l){l&&t(m),l&&t(h),D(f,l)}}}function us(U){let m,$,h,f,v;return f=new wa({props:{code:`import torch
from diffusers import DiffusionPipeline
from xformers.ops import MemoryEfficientAttentionFlashAttentionOp

pipe = DiffusionPipeline.from_pretrained("stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16)
pipe = pipe.to("cuda")
pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
# Workaround for not accepting attention shape using VAE for Flash Attention
pipe.vae.enable_xformers_memory_efficient_attention(attention_op=None)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> xformers.ops <span class="hljs-keyword">import</span> MemoryEfficientAttentionFlashAttentionOp

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Workaround for not accepting attention shape using VAE for Flash Attention</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.vae.enable_xformers_memory_efficient_attention(attention_op=<span class="hljs-literal">None</span>)`}}),{c(){m=a("p"),$=o("Examples:"),h=p(),y(f.$$.fragment)},l(l){m=s(l,"P",{});var _=i(m);$=r(_,"Examples:"),_.forEach(t),h=d(l),w(f.$$.fragment,l)},m(l,_){b(l,m,_),e(m,$),b(l,h,_),I(f,l,_),v=!0},p:ya,i(l){v||(P(f.$$.fragment,l),v=!0)},o(l){k(f.$$.fragment,l),v=!1},d(l){l&&t(m),l&&t(h),D(f,l)}}}function gs(U){let m,$,h,f,v;return f=new wa({props:{code:`import jax
import numpy as np
from flax.jax_utils import replicate
from flax.training.common_utils import shard
import PIL
import requests
from io import BytesIO
from diffusers import FlaxStableDiffusionInpaintPipeline


def download_image(url):
    response = requests.get(url)
    return PIL.Image.open(BytesIO(response.content)).convert("RGB")


img_url = "https://raw.githubusercontent.com/CompVis/latent-diffusion/main/data/inpainting_examples/overture-creations-5sI6fQgYIuo.png"
mask_url = "https://raw.githubusercontent.com/CompVis/latent-diffusion/main/data/inpainting_examples/overture-creations-5sI6fQgYIuo_mask.png"

init_image = download_image(img_url).resize((512, 512))
mask_image = download_image(mask_url).resize((512, 512))

pipeline, params = FlaxStableDiffusionInpaintPipeline.from_pretrained(
    "xvjiarui/stable-diffusion-2-inpainting"
)

prompt = "Face of a yellow cat, high resolution, sitting on a park bench"
prng_seed = jax.random.PRNGKey(0)
num_inference_steps = 50

num_samples = jax.device_count()
prompt = num_samples * [prompt]
init_image = num_samples * [init_image]
mask_image = num_samples * [mask_image]
prompt_ids, processed_masked_images, processed_masks = pipeline.prepare_inputs(
    prompt, init_image, mask_image
)

params = replicate(params)
prng_seed = jax.random.split(prng_seed, jax.device_count())
prompt_ids = shard(prompt_ids)
processed_masked_images = shard(processed_masked_images)
processed_masks = shard(processed_masks)

images = pipeline(
    prompt_ids, processed_masks, processed_masked_images, params, prng_seed, num_inference_steps, jit=True
).images
images = pipeline.numpy_to_pil(np.asarray(images.reshape((num_samples,) + images.shape[-3:])))`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> jax
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> flax.jax_utils <span class="hljs-keyword">import</span> replicate
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> flax.training.common_utils <span class="hljs-keyword">import</span> shard
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> PIL
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxStableDiffusionInpaintPipeline


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">download_image</span>(<span class="hljs-params">url</span>):
<span class="hljs-meta">... </span>    response = requests.get(url)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> PIL.Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)


<span class="hljs-meta">&gt;&gt;&gt; </span>img_url = <span class="hljs-string">&quot;https://raw.githubusercontent.com/CompVis/latent-diffusion/main/data/inpainting_examples/overture-creations-5sI6fQgYIuo.png&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_url = <span class="hljs-string">&quot;https://raw.githubusercontent.com/CompVis/latent-diffusion/main/data/inpainting_examples/overture-creations-5sI6fQgYIuo_mask.png&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>init_image = download_image(img_url).resize((<span class="hljs-number">512</span>, <span class="hljs-number">512</span>))
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_image = download_image(mask_url).resize((<span class="hljs-number">512</span>, <span class="hljs-number">512</span>))

<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline, params = FlaxStableDiffusionInpaintPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;xvjiarui/stable-diffusion-2-inpainting&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;Face of a yellow cat, high resolution, sitting on a park bench&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>prng_seed = jax.random.PRNGKey(<span class="hljs-number">0</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>num_inference_steps = <span class="hljs-number">50</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>num_samples = jax.device_count()
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = num_samples * [prompt]
<span class="hljs-meta">&gt;&gt;&gt; </span>init_image = num_samples * [init_image]
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_image = num_samples * [mask_image]
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_ids, processed_masked_images, processed_masks = pipeline.prepare_inputs(
<span class="hljs-meta">... </span>    prompt, init_image, mask_image
<span class="hljs-meta">... </span>)
<span class="hljs-comment"># shard inputs and rng</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>params = replicate(params)
<span class="hljs-meta">&gt;&gt;&gt; </span>prng_seed = jax.random.split(prng_seed, jax.device_count())
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_ids = shard(prompt_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>processed_masked_images = shard(processed_masked_images)
<span class="hljs-meta">&gt;&gt;&gt; </span>processed_masks = shard(processed_masks)

<span class="hljs-meta">&gt;&gt;&gt; </span>images = pipeline(
<span class="hljs-meta">... </span>    prompt_ids, processed_masks, processed_masked_images, params, prng_seed, num_inference_steps, jit=<span class="hljs-literal">True</span>
<span class="hljs-meta">... </span>).images
<span class="hljs-meta">&gt;&gt;&gt; </span>images = pipeline.numpy_to_pil(np.asarray(images.reshape((num_samples,) + images.shape[-<span class="hljs-number">3</span>:])))`}}),{c(){m=a("p"),$=o("Examples:"),h=p(),y(f.$$.fragment)},l(l){m=s(l,"P",{});var _=i(m);$=r(_,"Examples:"),_.forEach(t),h=d(l),w(f.$$.fragment,l)},m(l,_){b(l,m,_),e(m,$),b(l,h,_),I(f,l,_),v=!0},p:ya,i(l){v||(P(f.$$.fragment,l),v=!0)},o(l){k(f.$$.fragment,l),v=!1},d(l){l&&t(m),l&&t(h),D(f,l)}}}function hs(U){let m,$,h,f,v,l,_,qe,Lt,pt,N,V,Ae,Z,Mt,Oe,qt,dt,j,At,ee,Ot,Nt,te,zt,Ut,ne,Vt,Gt,ae,Wt,Bt,je,Kt,Qt,ct,Se,Rt,ft,G,se,Ne,Yt,Ht,ie,Jt,Xt,oe,ze,Zt,en,re,tn,mt,Ee,nn,ut,W,le,Ue,an,sn,pe,on,rn,de,Ve,ln,pn,ce,dn,gt,g,fe,cn,me,fn,Ge,mn,un,gn,ue,hn,Ce,_n,bn,vn,T,ge,xn,We,yn,wn,B,In,L,he,Pn,Be,kn,Dn,Ke,$n,jn,K,_e,Sn,be,En,Qe,Cn,Fn,Tn,S,ve,Ln,Re,Mn,qn,Ye,An,On,He,Nn,zn,Q,Un,R,xe,Vn,Je,Gn,Wn,Y,ye,Bn,E,Kn,Xe,Qn,Rn,Ze,Yn,Hn,et,Jn,Xn,tt,Zn,ea,ta,H,we,na,z,aa,nt,sa,ia,at,oa,ra,ht,C,Ie,la,Pe,pa,st,da,ca,fa,ke,ma,it,ua,ga,ha,M,De,_a,ot,ba,va,J,_t;return l=new rs({}),Z=new rs({}),fe=new O({props:{name:"class diffusers.StableDiffusionInpaintPipeline",anchor:"diffusers.StableDiffusionInpaintPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"scheduler",val:": KarrasDiffusionSchedulers"},{name:"safety_checker",val:": StableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPFeatureExtractor"},{name:"requires_safety_checker",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.StableDiffusionInpaintPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/pr_2770/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionInpaintPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionInpaintPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionInpaintPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/pr_2770/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionInpaintPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/pr_2770/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/pr_2770/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/pr_2770/en/api/schedulers/lms_discrete#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/pr_2770/en/api/schedulers/pndm#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.StableDiffusionInpaintPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.StableDiffusionInpaintPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPFeatureExtractor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2770/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_inpaint.py#L140"}}),ge=new O({props:{name:"__call__",anchor:"diffusers.StableDiffusionInpaintPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image] = None"},{name:"mask_image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image] = None"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": float = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"}],parametersDescription:[{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.image",description:`<strong>image</strong> (<code>PIL.Image.Image</code>) &#x2014;
<code>Image</code>, or tensor representing an image batch which will be inpainted, <em>i.e.</em> parts of the image will
be masked out with <code>mask_image</code> and repainted according to <code>prompt</code>.`,name:"image"},{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.mask_image",description:`<strong>mask_image</strong> (<code>PIL.Image.Image</code>) &#x2014;
<code>Image</code>, or tensor representing an image batch, to mask <code>image</code>. White pixels in the mask will be
repainted, while black pixels will be preserved. If <code>mask_image</code> is a PIL image, it will be converted
to a single channel (luminance) before use. If it&#x2019;s a tensor, it should contain one color channel (L)
instead of 3, so the expected shape would be <code>(B, H, W, 1)</code>.`,name:"mask_image"},{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code>. instead. Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code>
is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/pr_2770/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2770/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"}],source:"https://github.com/huggingface/diffusers/blob/vr_2770/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_inpaint.py#L627",returnDescription:`
<p><a
  href="/docs/diffusers/pr_2770/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_2770/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),B=new xa({props:{anchor:"diffusers.StableDiffusionInpaintPipeline.__call__.example",$$slots:{default:[ms]},$$scope:{ctx:U}}}),he=new O({props:{name:"enable_attention_slicing",anchor:"diffusers.StableDiffusionInpaintPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.StableDiffusionInpaintPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maximum amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/vr_2770/src/diffusers/pipelines/pipeline_utils.py#L1349"}}),_e=new O({props:{name:"disable_attention_slicing",anchor:"diffusers.StableDiffusionInpaintPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2770/src/diffusers/pipelines/pipeline_utils.py#L1365"}}),ve=new O({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionInpaintPipeline.enable_xformers_memory_efficient_attention",parameters:[{name:"attention_op",val:": typing.Optional[typing.Callable] = None"}],parametersDescription:[{anchor:"diffusers.StableDiffusionInpaintPipeline.enable_xformers_memory_efficient_attention.attention_op",description:`<strong>attention_op</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Override the default <code>None</code> operator for use as <code>op</code> argument to the
<a href="https://facebookresearch.github.io/xformers/components/ops.html#xformers.ops.memory_efficient_attention" rel="nofollow"><code>memory_efficient_attention()</code></a>
function of xFormers.`,name:"attention_op"}],source:"https://github.com/huggingface/diffusers/blob/vr_2770/src/diffusers/pipelines/pipeline_utils.py#L1292"}}),Q=new xa({props:{anchor:"diffusers.StableDiffusionInpaintPipeline.enable_xformers_memory_efficient_attention.example",$$slots:{default:[us]},$$scope:{ctx:U}}}),xe=new O({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionInpaintPipeline.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2770/src/diffusers/pipelines/pipeline_utils.py#L1324"}}),ye=new O({props:{name:"enable_model_cpu_offload",anchor:"diffusers.StableDiffusionInpaintPipeline.enable_model_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_2770/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_inpaint.py#L286"}}),we=new O({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionInpaintPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_2770/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_inpaint.py#L260"}}),Ie=new O({props:{name:"class diffusers.FlaxStableDiffusionInpaintPipeline",anchor:"diffusers.FlaxStableDiffusionInpaintPipeline",parameters:[{name:"vae",val:": FlaxAutoencoderKL"},{name:"text_encoder",val:": FlaxCLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": FlaxUNet2DConditionModel"},{name:"scheduler",val:": typing.Union[diffusers.schedulers.scheduling_ddim_flax.FlaxDDIMScheduler, diffusers.schedulers.scheduling_pndm_flax.FlaxPNDMScheduler, diffusers.schedulers.scheduling_lms_discrete_flax.FlaxLMSDiscreteScheduler, diffusers.schedulers.scheduling_dpmsolver_multistep_flax.FlaxDPMSolverMultistepScheduler]"},{name:"safety_checker",val:": FlaxStableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPFeatureExtractor"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"}],parametersDescription:[{anchor:"diffusers.FlaxStableDiffusionInpaintPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/pr_2770/en/api/models#diffusers.FlaxAutoencoderKL">FlaxAutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.FlaxStableDiffusionInpaintPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>FlaxCLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.FlaxCLIPTextModel" rel="nofollow">CLIP</a>,
specifically the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.FlaxStableDiffusionInpaintPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.FlaxStableDiffusionInpaintPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/pr_2770/en/api/models#diffusers.FlaxUNet2DConditionModel">FlaxUNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.FlaxStableDiffusionInpaintPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/pr_2770/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<code>FlaxDDIMScheduler</code>, <code>FlaxLMSDiscreteScheduler</code>, <code>FlaxPNDMScheduler</code>, or
<code>FlaxDPMSolverMultistepScheduler</code>.`,name:"scheduler"},{anchor:"diffusers.FlaxStableDiffusionInpaintPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>FlaxStableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.FlaxStableDiffusionInpaintPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPFeatureExtractor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2770/src/diffusers/pipelines/stable_diffusion/pipeline_flax_stable_diffusion_inpaint.py#L102"}}),De=new O({props:{name:"__call__",anchor:"diffusers.FlaxStableDiffusionInpaintPipeline.__call__",parameters:[{name:"prompt_ids",val:": array"},{name:"mask",val:": array"},{name:"masked_image",val:": array"},{name:"params",val:": typing.Union[typing.Dict, flax.core.frozen_dict.FrozenDict]"},{name:"prng_seed",val:": PRNGKeyArray"},{name:"num_inference_steps",val:": int = 50"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"guidance_scale",val:": typing.Union[float, array] = 7.5"},{name:"latents",val:": array = None"},{name:"neg_prompt_ids",val:": array = None"},{name:"return_dict",val:": bool = True"},{name:"jit",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.FlaxStableDiffusionInpaintPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>) &#x2014;
The prompt or prompts to guide the image generation.`,name:"prompt"},{anchor:"diffusers.FlaxStableDiffusionInpaintPipeline.__call__.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.FlaxStableDiffusionInpaintPipeline.__call__.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.FlaxStableDiffusionInpaintPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.FlaxStableDiffusionInpaintPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.FlaxStableDiffusionInpaintPipeline.__call__.latents",description:`<strong>latents</strong> (<code>jnp.array</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. tensor will ge generated
by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.FlaxStableDiffusionInpaintPipeline.__call__.jit",description:`<strong>jit</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to run <code>pmap</code> versions of the generation and safety scoring functions. NOTE: This argument
exists because <code>__call__</code> is not yet end-to-end pmap-able. It will be removed in a future release.`,name:"jit"},{anchor:"diffusers.FlaxStableDiffusionInpaintPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>FlaxStableDiffusionPipelineOutput</code> instead of
a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/vr_2770/src/diffusers/pipelines/stable_diffusion/pipeline_flax_stable_diffusion_inpaint.py#L389",returnDescription:`
<p><code>FlaxStableDiffusionPipelineOutput</code> if <code>return_dict</code> is True, otherwise a
<code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><code>FlaxStableDiffusionPipelineOutput</code> or <code>tuple</code></p>
`}}),J=new xa({props:{anchor:"diffusers.FlaxStableDiffusionInpaintPipeline.__call__.example",$$slots:{default:[gs]},$$scope:{ctx:U}}}),{c(){m=a("meta"),$=p(),h=a("h1"),f=a("a"),v=a("span"),y(l.$$.fragment),_=p(),qe=a("span"),Lt=o("Text-Guided Image Inpainting"),pt=p(),N=a("h2"),V=a("a"),Ae=a("span"),y(Z.$$.fragment),Mt=p(),Oe=a("span"),qt=o("StableDiffusionInpaintPipeline"),dt=p(),j=a("p"),At=o("The Stable Diffusion model was created by the researchers and engineers from "),ee=a("a"),Ot=o("CompVis"),Nt=o(", "),te=a("a"),zt=o("Stability AI"),Ut=o(", "),ne=a("a"),Vt=o("runway"),Gt=o(", and "),ae=a("a"),Wt=o("LAION"),Bt=o(". The "),je=a("a"),Kt=o("StableDiffusionInpaintPipeline"),Qt=o(" lets you edit specific parts of an image by providing a mask and a text prompt using Stable Diffusion."),ct=p(),Se=a("p"),Rt=o("The original codebase can be found here:"),ft=p(),G=a("ul"),se=a("li"),Ne=a("em"),Yt=o("Stable Diffusion V1"),Ht=o(": "),ie=a("a"),Jt=o("CampVis/stable-diffusion"),Xt=p(),oe=a("li"),ze=a("em"),Zt=o("Stable Diffusion V2"),en=o(": "),re=a("a"),tn=o("Stability-AI/stablediffusion"),mt=p(),Ee=a("p"),nn=o("Available checkpoints are:"),ut=p(),W=a("ul"),le=a("li"),Ue=a("em"),an=o("stable-diffusion-inpainting (512x512 resolution)"),sn=o(": "),pe=a("a"),on=o("runwayml/stable-diffusion-inpainting"),rn=p(),de=a("li"),Ve=a("em"),ln=o("stable-diffusion-2-inpainting (512x512 resolution)"),pn=o(": "),ce=a("a"),dn=o("stabilityai/stable-diffusion-2-inpainting"),gt=p(),g=a("div"),y(fe.$$.fragment),cn=p(),me=a("p"),fn=o("Pipeline for text-guided image inpainting using Stable Diffusion. "),Ge=a("em"),mn=o("This is an experimental feature"),un=o("."),gn=p(),ue=a("p"),hn=o("This model inherits from "),Ce=a("a"),_n=o("DiffusionPipeline"),bn=o(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),vn=p(),T=a("div"),y(ge.$$.fragment),xn=p(),We=a("p"),yn=o("Function invoked when calling the pipeline for generation."),wn=p(),y(B.$$.fragment),In=p(),L=a("div"),y(he.$$.fragment),Pn=p(),Be=a("p"),kn=o("Enable sliced attention computation."),Dn=p(),Ke=a("p"),$n=o(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),jn=p(),K=a("div"),y(_e.$$.fragment),Sn=p(),be=a("p"),En=o("Disable sliced attention computation. If "),Qe=a("code"),Cn=o("enable_attention_slicing"),Fn=o(` was previously invoked, this method will go
back to computing attention in one step.`),Tn=p(),S=a("div"),y(ve.$$.fragment),Ln=p(),Re=a("p"),Mn=o("Enable memory efficient attention as implemented in xformers."),qn=p(),Ye=a("p"),An=o(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),On=p(),He=a("p"),Nn=o(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),zn=p(),y(Q.$$.fragment),Un=p(),R=a("div"),y(xe.$$.fragment),Vn=p(),Je=a("p"),Gn=o("Disable memory efficient attention as implemented in xformers."),Wn=p(),Y=a("div"),y(ye.$$.fragment),Bn=p(),E=a("p"),Kn=o(`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),Xe=a("code"),Qn=o("enable_sequential_cpu_offload"),Rn=o(", this method moves one whole model at a time to the GPU when its "),Ze=a("code"),Yn=o("forward"),Hn=o(`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),et=a("code"),Jn=o("enable_sequential_cpu_offload"),Xn=o(", but performance is much better due to the iterative execution of the "),tt=a("code"),Zn=o("unet"),ea=o("."),ta=p(),H=a("div"),y(we.$$.fragment),na=p(),z=a("p"),aa=o(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),nt=a("code"),sa=o("torch.device('meta') and loaded to GPU only when their specific submodule has its "),ia=o("forward"),at=a("code"),oa=o("method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),ra=o("enable_model_cpu_offload`, but performance is lower."),ht=p(),C=a("div"),y(Ie.$$.fragment),la=p(),Pe=a("p"),pa=o("Pipeline for text-guided image inpainting using Stable Diffusion. "),st=a("em"),da=o("This is an experimental feature"),ca=o("."),fa=p(),ke=a("p"),ma=o("This model inherits from "),it=a("code"),ua=o("FlaxDiffusionPipeline"),ga=o(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),ha=p(),M=a("div"),y(De.$$.fragment),_a=p(),ot=a("p"),ba=o("Function invoked when calling the pipeline for generation."),va=p(),y(J.$$.fragment),this.h()},l(n){const u=cs('[data-svelte="svelte-1phssyn"]',document.head);m=s(u,"META",{name:!0,content:!0}),u.forEach(t),$=d(n),h=s(n,"H1",{class:!0});var $e=i(h);f=s($e,"A",{id:!0,class:!0,href:!0});var rt=i(f);v=s(rt,"SPAN",{});var lt=i(v);w(l.$$.fragment,lt),lt.forEach(t),rt.forEach(t),_=d($e),qe=s($e,"SPAN",{});var Ia=i(qe);Lt=r(Ia,"Text-Guided Image Inpainting"),Ia.forEach(t),$e.forEach(t),pt=d(n),N=s(n,"H2",{class:!0});var bt=i(N);V=s(bt,"A",{id:!0,class:!0,href:!0});var Pa=i(V);Ae=s(Pa,"SPAN",{});var ka=i(Ae);w(Z.$$.fragment,ka),ka.forEach(t),Pa.forEach(t),Mt=d(bt),Oe=s(bt,"SPAN",{});var Da=i(Oe);qt=r(Da,"StableDiffusionInpaintPipeline"),Da.forEach(t),bt.forEach(t),dt=d(n),j=s(n,"P",{});var F=i(j);At=r(F,"The Stable Diffusion model was created by the researchers and engineers from "),ee=s(F,"A",{href:!0,rel:!0});var $a=i(ee);Ot=r($a,"CompVis"),$a.forEach(t),Nt=r(F,", "),te=s(F,"A",{href:!0,rel:!0});var ja=i(te);zt=r(ja,"Stability AI"),ja.forEach(t),Ut=r(F,", "),ne=s(F,"A",{href:!0,rel:!0});var Sa=i(ne);Vt=r(Sa,"runway"),Sa.forEach(t),Gt=r(F,", and "),ae=s(F,"A",{href:!0,rel:!0});var Ea=i(ae);Wt=r(Ea,"LAION"),Ea.forEach(t),Bt=r(F,". The "),je=s(F,"A",{href:!0});var Ca=i(je);Kt=r(Ca,"StableDiffusionInpaintPipeline"),Ca.forEach(t),Qt=r(F," lets you edit specific parts of an image by providing a mask and a text prompt using Stable Diffusion."),F.forEach(t),ct=d(n),Se=s(n,"P",{});var Fa=i(Se);Rt=r(Fa,"The original codebase can be found here:"),Fa.forEach(t),ft=d(n),G=s(n,"UL",{});var vt=i(G);se=s(vt,"LI",{});var xt=i(se);Ne=s(xt,"EM",{});var Ta=i(Ne);Yt=r(Ta,"Stable Diffusion V1"),Ta.forEach(t),Ht=r(xt,": "),ie=s(xt,"A",{href:!0,rel:!0});var La=i(ie);Jt=r(La,"CampVis/stable-diffusion"),La.forEach(t),xt.forEach(t),Xt=d(vt),oe=s(vt,"LI",{});var yt=i(oe);ze=s(yt,"EM",{});var Ma=i(ze);Zt=r(Ma,"Stable Diffusion V2"),Ma.forEach(t),en=r(yt,": "),re=s(yt,"A",{href:!0,rel:!0});var qa=i(re);tn=r(qa,"Stability-AI/stablediffusion"),qa.forEach(t),yt.forEach(t),vt.forEach(t),mt=d(n),Ee=s(n,"P",{});var Aa=i(Ee);nn=r(Aa,"Available checkpoints are:"),Aa.forEach(t),ut=d(n),W=s(n,"UL",{});var wt=i(W);le=s(wt,"LI",{});var It=i(le);Ue=s(It,"EM",{});var Oa=i(Ue);an=r(Oa,"stable-diffusion-inpainting (512x512 resolution)"),Oa.forEach(t),sn=r(It,": "),pe=s(It,"A",{href:!0,rel:!0});var Na=i(pe);on=r(Na,"runwayml/stable-diffusion-inpainting"),Na.forEach(t),It.forEach(t),rn=d(wt),de=s(wt,"LI",{});var Pt=i(de);Ve=s(Pt,"EM",{});var za=i(Ve);ln=r(za,"stable-diffusion-2-inpainting (512x512 resolution)"),za.forEach(t),pn=r(Pt,": "),ce=s(Pt,"A",{href:!0,rel:!0});var Ua=i(ce);dn=r(Ua,"stabilityai/stable-diffusion-2-inpainting"),Ua.forEach(t),Pt.forEach(t),wt.forEach(t),gt=d(n),g=s(n,"DIV",{class:!0});var x=i(g);w(fe.$$.fragment,x),cn=d(x),me=s(x,"P",{});var kt=i(me);fn=r(kt,"Pipeline for text-guided image inpainting using Stable Diffusion. "),Ge=s(kt,"EM",{});var Va=i(Ge);mn=r(Va,"This is an experimental feature"),Va.forEach(t),un=r(kt,"."),kt.forEach(t),gn=d(x),ue=s(x,"P",{});var Dt=i(ue);hn=r(Dt,"This model inherits from "),Ce=s(Dt,"A",{href:!0});var Ga=i(Ce);_n=r(Ga,"DiffusionPipeline"),Ga.forEach(t),bn=r(Dt,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Dt.forEach(t),vn=d(x),T=s(x,"DIV",{class:!0});var Fe=i(T);w(ge.$$.fragment,Fe),xn=d(Fe),We=s(Fe,"P",{});var Wa=i(We);yn=r(Wa,"Function invoked when calling the pipeline for generation."),Wa.forEach(t),wn=d(Fe),w(B.$$.fragment,Fe),Fe.forEach(t),In=d(x),L=s(x,"DIV",{class:!0});var Te=i(L);w(he.$$.fragment,Te),Pn=d(Te),Be=s(Te,"P",{});var Ba=i(Be);kn=r(Ba,"Enable sliced attention computation."),Ba.forEach(t),Dn=d(Te),Ke=s(Te,"P",{});var Ka=i(Ke);$n=r(Ka,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Ka.forEach(t),Te.forEach(t),jn=d(x),K=s(x,"DIV",{class:!0});var $t=i(K);w(_e.$$.fragment,$t),Sn=d($t),be=s($t,"P",{});var jt=i(be);En=r(jt,"Disable sliced attention computation. If "),Qe=s(jt,"CODE",{});var Qa=i(Qe);Cn=r(Qa,"enable_attention_slicing"),Qa.forEach(t),Fn=r(jt,` was previously invoked, this method will go
back to computing attention in one step.`),jt.forEach(t),$t.forEach(t),Tn=d(x),S=s(x,"DIV",{class:!0});var q=i(S);w(ve.$$.fragment,q),Ln=d(q),Re=s(q,"P",{});var Ra=i(Re);Mn=r(Ra,"Enable memory efficient attention as implemented in xformers."),Ra.forEach(t),qn=d(q),Ye=s(q,"P",{});var Ya=i(Ye);An=r(Ya,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),Ya.forEach(t),On=d(q),He=s(q,"P",{});var Ha=i(He);Nn=r(Ha,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),Ha.forEach(t),zn=d(q),w(Q.$$.fragment,q),q.forEach(t),Un=d(x),R=s(x,"DIV",{class:!0});var St=i(R);w(xe.$$.fragment,St),Vn=d(St),Je=s(St,"P",{});var Ja=i(Je);Gn=r(Ja,"Disable memory efficient attention as implemented in xformers."),Ja.forEach(t),St.forEach(t),Wn=d(x),Y=s(x,"DIV",{class:!0});var Et=i(Y);w(ye.$$.fragment,Et),Bn=d(Et),E=s(Et,"P",{});var A=i(E);Kn=r(A,`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),Xe=s(A,"CODE",{});var Xa=i(Xe);Qn=r(Xa,"enable_sequential_cpu_offload"),Xa.forEach(t),Rn=r(A,", this method moves one whole model at a time to the GPU when its "),Ze=s(A,"CODE",{});var Za=i(Ze);Yn=r(Za,"forward"),Za.forEach(t),Hn=r(A,`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),et=s(A,"CODE",{});var es=i(et);Jn=r(es,"enable_sequential_cpu_offload"),es.forEach(t),Xn=r(A,", but performance is much better due to the iterative execution of the "),tt=s(A,"CODE",{});var ts=i(tt);Zn=r(ts,"unet"),ts.forEach(t),ea=r(A,"."),A.forEach(t),Et.forEach(t),ta=d(x),H=s(x,"DIV",{class:!0});var Ct=i(H);w(we.$$.fragment,Ct),na=d(Ct),z=s(Ct,"P",{});var Le=i(z);aa=r(Le,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),nt=s(Le,"CODE",{});var ns=i(nt);sa=r(ns,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),ns.forEach(t),ia=r(Le,"forward"),at=s(Le,"CODE",{});var as=i(at);oa=r(as,"method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),as.forEach(t),ra=r(Le,"enable_model_cpu_offload`, but performance is lower."),Le.forEach(t),Ct.forEach(t),x.forEach(t),ht=d(n),C=s(n,"DIV",{class:!0});var X=i(C);w(Ie.$$.fragment,X),la=d(X),Pe=s(X,"P",{});var Ft=i(Pe);pa=r(Ft,"Pipeline for text-guided image inpainting using Stable Diffusion. "),st=s(Ft,"EM",{});var ss=i(st);da=r(ss,"This is an experimental feature"),ss.forEach(t),ca=r(Ft,"."),Ft.forEach(t),fa=d(X),ke=s(X,"P",{});var Tt=i(ke);ma=r(Tt,"This model inherits from "),it=s(Tt,"CODE",{});var is=i(it);ua=r(is,"FlaxDiffusionPipeline"),is.forEach(t),ga=r(Tt,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Tt.forEach(t),ha=d(X),M=s(X,"DIV",{class:!0});var Me=i(M);w(De.$$.fragment,Me),_a=d(Me),ot=s(Me,"P",{});var os=i(ot);ba=r(os,"Function invoked when calling the pipeline for generation."),os.forEach(t),va=d(Me),w(J.$$.fragment,Me),Me.forEach(t),X.forEach(t),this.h()},h(){c(m,"name","hf:doc:metadata"),c(m,"content",JSON.stringify(_s)),c(f,"id","textguided-image-inpainting"),c(f,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(f,"href","#textguided-image-inpainting"),c(h,"class","relative group"),c(V,"id","diffusers.StableDiffusionInpaintPipeline"),c(V,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(V,"href","#diffusers.StableDiffusionInpaintPipeline"),c(N,"class","relative group"),c(ee,"href","https://github.com/CompVis"),c(ee,"rel","nofollow"),c(te,"href","https://stability.ai/"),c(te,"rel","nofollow"),c(ne,"href","https://github.com/runwayml"),c(ne,"rel","nofollow"),c(ae,"href","https://laion.ai/"),c(ae,"rel","nofollow"),c(je,"href","/docs/diffusers/pr_2770/en/api/pipelines/stable_diffusion/inpaint#diffusers.StableDiffusionInpaintPipeline"),c(ie,"href","https://github.com/runwayml/stable-diffusion#inpainting-with-stable-diffusion"),c(ie,"rel","nofollow"),c(re,"href","https://github.com/Stability-AI/stablediffusion#image-inpainting-with-stable-diffusion"),c(re,"rel","nofollow"),c(pe,"href","https://huggingface.co/runwayml/stable-diffusion-inpainting"),c(pe,"rel","nofollow"),c(ce,"href","https://huggingface.co/stabilityai/stable-diffusion-2-inpainting"),c(ce,"rel","nofollow"),c(Ce,"href","/docs/diffusers/pr_2770/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),c(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(g,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(n,u){e(document.head,m),b(n,$,u),b(n,h,u),e(h,f),e(f,v),I(l,v,null),e(h,_),e(h,qe),e(qe,Lt),b(n,pt,u),b(n,N,u),e(N,V),e(V,Ae),I(Z,Ae,null),e(N,Mt),e(N,Oe),e(Oe,qt),b(n,dt,u),b(n,j,u),e(j,At),e(j,ee),e(ee,Ot),e(j,Nt),e(j,te),e(te,zt),e(j,Ut),e(j,ne),e(ne,Vt),e(j,Gt),e(j,ae),e(ae,Wt),e(j,Bt),e(j,je),e(je,Kt),e(j,Qt),b(n,ct,u),b(n,Se,u),e(Se,Rt),b(n,ft,u),b(n,G,u),e(G,se),e(se,Ne),e(Ne,Yt),e(se,Ht),e(se,ie),e(ie,Jt),e(G,Xt),e(G,oe),e(oe,ze),e(ze,Zt),e(oe,en),e(oe,re),e(re,tn),b(n,mt,u),b(n,Ee,u),e(Ee,nn),b(n,ut,u),b(n,W,u),e(W,le),e(le,Ue),e(Ue,an),e(le,sn),e(le,pe),e(pe,on),e(W,rn),e(W,de),e(de,Ve),e(Ve,ln),e(de,pn),e(de,ce),e(ce,dn),b(n,gt,u),b(n,g,u),I(fe,g,null),e(g,cn),e(g,me),e(me,fn),e(me,Ge),e(Ge,mn),e(me,un),e(g,gn),e(g,ue),e(ue,hn),e(ue,Ce),e(Ce,_n),e(ue,bn),e(g,vn),e(g,T),I(ge,T,null),e(T,xn),e(T,We),e(We,yn),e(T,wn),I(B,T,null),e(g,In),e(g,L),I(he,L,null),e(L,Pn),e(L,Be),e(Be,kn),e(L,Dn),e(L,Ke),e(Ke,$n),e(g,jn),e(g,K),I(_e,K,null),e(K,Sn),e(K,be),e(be,En),e(be,Qe),e(Qe,Cn),e(be,Fn),e(g,Tn),e(g,S),I(ve,S,null),e(S,Ln),e(S,Re),e(Re,Mn),e(S,qn),e(S,Ye),e(Ye,An),e(S,On),e(S,He),e(He,Nn),e(S,zn),I(Q,S,null),e(g,Un),e(g,R),I(xe,R,null),e(R,Vn),e(R,Je),e(Je,Gn),e(g,Wn),e(g,Y),I(ye,Y,null),e(Y,Bn),e(Y,E),e(E,Kn),e(E,Xe),e(Xe,Qn),e(E,Rn),e(E,Ze),e(Ze,Yn),e(E,Hn),e(E,et),e(et,Jn),e(E,Xn),e(E,tt),e(tt,Zn),e(E,ea),e(g,ta),e(g,H),I(we,H,null),e(H,na),e(H,z),e(z,aa),e(z,nt),e(nt,sa),e(z,ia),e(z,at),e(at,oa),e(z,ra),b(n,ht,u),b(n,C,u),I(Ie,C,null),e(C,la),e(C,Pe),e(Pe,pa),e(Pe,st),e(st,da),e(Pe,ca),e(C,fa),e(C,ke),e(ke,ma),e(ke,it),e(it,ua),e(ke,ga),e(C,ha),e(C,M),I(De,M,null),e(M,_a),e(M,ot),e(ot,ba),e(M,va),I(J,M,null),_t=!0},p(n,[u]){const $e={};u&2&&($e.$$scope={dirty:u,ctx:n}),B.$set($e);const rt={};u&2&&(rt.$$scope={dirty:u,ctx:n}),Q.$set(rt);const lt={};u&2&&(lt.$$scope={dirty:u,ctx:n}),J.$set(lt)},i(n){_t||(P(l.$$.fragment,n),P(Z.$$.fragment,n),P(fe.$$.fragment,n),P(ge.$$.fragment,n),P(B.$$.fragment,n),P(he.$$.fragment,n),P(_e.$$.fragment,n),P(ve.$$.fragment,n),P(Q.$$.fragment,n),P(xe.$$.fragment,n),P(ye.$$.fragment,n),P(we.$$.fragment,n),P(Ie.$$.fragment,n),P(De.$$.fragment,n),P(J.$$.fragment,n),_t=!0)},o(n){k(l.$$.fragment,n),k(Z.$$.fragment,n),k(fe.$$.fragment,n),k(ge.$$.fragment,n),k(B.$$.fragment,n),k(he.$$.fragment,n),k(_e.$$.fragment,n),k(ve.$$.fragment,n),k(Q.$$.fragment,n),k(xe.$$.fragment,n),k(ye.$$.fragment,n),k(we.$$.fragment,n),k(Ie.$$.fragment,n),k(De.$$.fragment,n),k(J.$$.fragment,n),_t=!1},d(n){t(m),n&&t($),n&&t(h),D(l),n&&t(pt),n&&t(N),D(Z),n&&t(dt),n&&t(j),n&&t(ct),n&&t(Se),n&&t(ft),n&&t(G),n&&t(mt),n&&t(Ee),n&&t(ut),n&&t(W),n&&t(gt),n&&t(g),D(fe),D(ge),D(B),D(he),D(_e),D(ve),D(Q),D(xe),D(ye),D(we),n&&t(ht),n&&t(C),D(Ie),D(De),D(J)}}}const _s={local:"textguided-image-inpainting",sections:[{local:"diffusers.StableDiffusionInpaintPipeline",title:"StableDiffusionInpaintPipeline"}],title:"Text-Guided Image Inpainting"};function bs(U){return fs(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ps extends ls{constructor(m){super();ps(this,m,bs,hs,ds,{})}}export{Ps as default,_s as metadata};
